package com.blamejared.compat.tconstruct.materials;

import slimeknights.tconstruct.library.materials.BowStringMaterialStats;
import com.blamejared.compat.tconstruct.actions.SetBowBonusDamageAction;
import com.blamejared.compat.tconstruct.actions.SetBowRangeAction;
import com.blamejared.compat.tconstruct.actions.SetDrawSpeedAction;
import slimeknights.tconstruct.library.materials.BowMaterialStats;
import slimeknights.tconstruct.library.materials.FletchingMaterialStats;
import slimeknights.tconstruct.library.materials.ArrowShaftMaterialStats;
import slimeknights.tconstruct.library.materials.ExtraMaterialStats;
import com.blamejared.compat.tconstruct.actions.SetModifierAction;
import slimeknights.tconstruct.library.materials.HandleMaterialStats;
import com.blamejared.compat.tconstruct.actions.SetHarvestLevelAction;
import com.blamejared.compat.tconstruct.actions.SetAttackAction;
import com.blamejared.compat.tconstruct.actions.SetMiningSpeedAction;
import slimeknights.tconstruct.library.materials.HeadMaterialStats;
import crafttweaker.IAction;
import crafttweaker.CraftTweakerAPI;
import com.blamejared.compat.tconstruct.actions.SetDurabilityAction;
import slimeknights.tconstruct.library.materials.Material;

public class TICMaterial implements ITICMaterial
{
    private final Material material;
    
    public TICMaterial(final Material material) {
        this.material = material;
    }
    
    @Override
    public String getName() {
        return this.material.getIdentifier();
    }
    
    @Override
    public boolean matches(final ITICMaterial var1) {
        return var1.getName().equals(this.getName());
    }
    
    @Override
    public Object getInternal() {
        return this.material;
    }
    
    @Override
    public ITICMaterialDefinition getDefinition() {
        return new TICMaterialDefinition(this.material);
    }
    
    @Override
    public void setDurabilityHead(final int durability) {
        CraftTweakerAPI.apply((IAction)new SetDurabilityAction((ITICMaterial)this, "head", durability));
    }
    
    @Override
    public int getDurabilityHead() {
        return ((HeadMaterialStats)this.material.getStats("head")).durability;
    }
    
    @Override
    public void setMiningSpeedHead(final float miningSpeed) {
        CraftTweakerAPI.apply((IAction)new SetMiningSpeedAction((ITICMaterial)this, "head", miningSpeed));
    }
    
    @Override
    public float getMiningSpeedHead() {
        return ((HeadMaterialStats)this.material.getStats("head")).miningspeed;
    }
    
    @Override
    public void setAttackHead(final float attack) {
        CraftTweakerAPI.apply((IAction)new SetAttackAction((ITICMaterial)this, "head", attack));
    }
    
    @Override
    public float getAttackHead() {
        return ((HeadMaterialStats)this.material.getStats("head")).attack;
    }
    
    @Override
    public void setHarvestLevelHead(final int level) {
        CraftTweakerAPI.apply((IAction)new SetHarvestLevelAction((ITICMaterial)this, "head", level));
    }
    
    @Override
    public int getHarvestLevelHead() {
        return ((HeadMaterialStats)this.material.getStats("head")).harvestLevel;
    }
    
    @Override
    public void setDurabilityHandle(final int durability) {
        CraftTweakerAPI.apply((IAction)new SetDurabilityAction((ITICMaterial)this, "handle", durability));
    }
    
    @Override
    public int getDurabilityHandle() {
        return ((HandleMaterialStats)this.material.getStats("handle")).durability;
    }
    
    @Override
    public void setModifierHandle(final float modifier) {
        CraftTweakerAPI.apply((IAction)new SetModifierAction((ITICMaterial)this, "handle", modifier));
    }
    
    @Override
    public float getModifierHandle() {
        return ((HandleMaterialStats)this.material.getStats("handle")).modifier;
    }
    
    @Override
    public void setDurabilityExtra(final int durability) {
        CraftTweakerAPI.apply((IAction)new SetDurabilityAction((ITICMaterial)this, "extra", durability));
    }
    
    @Override
    public int getDurabilityExtra() {
        return ((ExtraMaterialStats)this.material.getStats("extra")).extraDurability;
    }
    
    @Override
    public void setArrowModifier(final float modifier) {
        CraftTweakerAPI.apply((IAction)new SetModifierAction((ITICMaterial)this, "shaft", modifier));
    }
    
    @Override
    public float getArrowModifier() {
        return ((ArrowShaftMaterialStats)this.material.getStats("shaft")).modifier;
    }
    
    @Override
    public void setArrowBonusAmmo(final int bonusAmmo) {
        CraftTweakerAPI.apply((IAction)new SetDurabilityAction((ITICMaterial)this, "shaft", bonusAmmo));
    }
    
    @Override
    public int getArrowBonusAmmo() {
        return ((ArrowShaftMaterialStats)this.material.getStats("shaft")).bonusAmmo;
    }
    
    @Override
    public void setFletchingModifier(final float modifier) {
        CraftTweakerAPI.apply((IAction)new SetModifierAction((ITICMaterial)this, "fletching", modifier));
    }
    
    @Override
    public float getFletchingModifier() {
        return ((FletchingMaterialStats)this.material.getStats("fletching")).modifier;
    }
    
    @Override
    public void setFletchingAccuracy(final float accuracy) {
        CraftTweakerAPI.apply((IAction)new SetAttackAction((ITICMaterial)this, "fletching", accuracy));
    }
    
    @Override
    public float getFletchingAccuracy() {
        return ((FletchingMaterialStats)this.material.getStats("fletching")).accuracy;
    }
    
    @Override
    public float getBowDrawSpeed() {
        return ((BowMaterialStats)this.material.getStats("bow")).drawspeed;
    }
    
    @Override
    public void setBowDrawSpeed(final float drawSpeed) {
        CraftTweakerAPI.apply((IAction)new SetDrawSpeedAction((ITICMaterial)this, "bow", drawSpeed));
    }
    
    @Override
    public float getBowRange() {
        return ((BowMaterialStats)this.material.getStats("bow")).range;
    }
    
    @Override
    public void setBowRange(final float range) {
        CraftTweakerAPI.apply((IAction)new SetBowRangeAction((ITICMaterial)this, "bow", range));
    }
    
    @Override
    public float getBonusDamage() {
        return ((BowMaterialStats)this.material.getStats("bow")).bonusDamage;
    }
    
    @Override
    public void setBonusDamage(final float bonusDamage) {
        CraftTweakerAPI.apply((IAction)new SetBowBonusDamageAction((ITICMaterial)this, "bow", bonusDamage));
    }
    
    @Override
    public float getBowStringModifier() {
        return ((BowStringMaterialStats)this.material.getStats("bowstring")).modifier;
    }
    
    @Override
    public void setBowStringModifier(final float modifier) {
        CraftTweakerAPI.apply((IAction)new SetModifierAction((ITICMaterial)this, "bowstring", modifier));
    }
}
